/********************************************************************************/
/*										*/
/*	                       .	                        */
/*								   		*/
/********************************************************************************/
#include "..\main\mktstr.h"
//#include "speed.h"


/*------------------------------------------------------------------------------*/
/*     /.                                       */
/*    .                                           */
/*------------------------------------------------------------------------------*/
unsigned char data Cur_Speed;

/*------------------------------------------------------------------------------*/
/*        /.                    */
/*------------------------------------------------------------------------------*/
unsigned char data Prev_Speed;

/*------------------------------------------------------------------------------*/
/*       32,768-  .            */
/*------------------------------------------------------------------------------*/
unsigned char Speed_Interval;

/*------------------------------------------------------------------------------*/
/* ,      .                        */
/*------------------------------------------------------------------------------*/
unsigned char Speed_Buffer[5];

/*------------------------------------------------------------------------------*/
/*     .			        */
/* :     .                                            */
/* :    .                                           */
/*------------------------------------------------------------------------------*/
void Init_Speedometer(void)
{
  /*        INT0.                       */
  TCON|=0x01;                   //  INT0  .

  /*  1       .         */
  TMOD&=0x0f; TMOD|=0x10;       //  1   1 , .
  TL1=TH1=0; Speed_Interval=0;
  TR1=0;

  Cur_Speed=Prev_Speed=0;
  Speed_Buffer[0]=Speed_Buffer[1]=Speed_Buffer[2]=Speed_Buffer[3]=Speed_Buffer[4]=0;

  ET1=1; EX0=1;                 //    INT0  T1.

  return;
}

/*------------------------------------------------------------------------------*/
/*     INT0 -    .             */
/*------------------------------------------------------------------------------*/
void IRQ_Speedometer_Lable(void) interrupt 0
{
  //         0.5 .
  union LONG_INT
    {
      unsigned long int Long;
      unsigned int Int;
      unsigned char Byte[4];
    };
  union LONG_INT Interval;
  unsigned int Tmp;

  TR1=0;
  Interval.Byte[3]=TL1; Interval.Byte[2]=TH1;
  Interval.Byte[1]=Speed_Interval; Interval.Byte[0]=0;
  TH1=TL1=0;
  Speed_Interval=0;
  TR1=1;

  //    .
  Tmp=((16666666/Interval.Long)*72)/100;
  Cur_Speed=Tmp/10;
  if((Tmp%10) >= 5) Cur_Speed++;

  //    (    7 /).
  if(Cur_Speed > Prev_Speed)
    {
      if((Cur_Speed-Prev_Speed) > 7) Cur_Speed=Prev_Speed+7;
    }
  else
    {
      if((Prev_Speed-Cur_Speed) > 7) Cur_Speed=Prev_Speed-7;
    }

  //      5 .
  //         .
  Speed_Buffer[0]=Speed_Buffer[1];
  Speed_Buffer[1]=Speed_Buffer[2];
  Speed_Buffer[2]=Speed_Buffer[3];
  Speed_Buffer[3]=Speed_Buffer[4];
  Speed_Buffer[4]=Cur_Speed;

  //   .
  Interval.Int=(unsigned int)(Speed_Buffer[0])+(unsigned int)(Speed_Buffer[1])+
               (unsigned int)(Speed_Buffer[2])+(unsigned int)(Speed_Buffer[3])+
               (unsigned int)(Speed_Buffer[4]);
  Cur_Speed=Interval.Int/5;
  Prev_Speed=Cur_Speed;

  // ,     .
  if((Trip_Params.State&0x01) != 0)
    {
      // ,      .
      //   -     .
      if(Cur_Speed > Trip_Params.Peak_Speed) Trip_Params.Peak_Speed=Cur_Speed;

      //    .
      Trip_Params.Passed_Distance++;
    }

  return;
}

/*------------------------------------------------------------------------------*/
/*      1.                             */
/*------------------------------------------------------------------------------*/
void Timer1_Overflow_Interrupt(void) interrupt 3
{
  //   500  -  .
  if(Speed_Interval <= 16) Speed_Interval++;
  else Cur_Speed=Prev_Speed=0;

  return;
}

